# SPDX-FileCopyrightText: Copyright (c) 2024, Linaro Limited.
#
# SPDX-License-Identifier: MIT
---

device_type: fvp
job_name: {{ CI_JOB_NAME }}

timeouts:
  connections:
    auto-login-action:
      minutes: 10
    login-action:
      minutes: 10
  job:
    minutes: 600
  actions:
    auto-login-action:
      minutes: 15
    fvp-deploy:
      minutes: 20
    download-retry:
      minutes: 20
    http-download:
      minutes: 20

metadata:
  source: {{ CI_PROJECT_URL }}
  path: .gitlab/lava/corstone1000-fvp/idt_greengrass.yml.j2
  gitlab-job-url: {{ CI_JOB_URL }}

{%- if FREQUENCY == 'adhoc' %}
priority: medium
{%- else %}
priority: low
{%- endif %}
visibility:
  group:
    - cassini

context:
  boot_character_delay: 250
  test_character_delay: 250

notify:
  criteria:
    status: finished
  callbacks:
    - url: "{{ CI_API_V4_URL }}/projects/{{ CI_PROJECT_ID }}/jobs/{{ TEST_COMPLETE_JOB_ID }}/play"
      method: POST
      token: "{{ LAVA_CALLBACK_TOKEN }}"
      header: "PRIVATE-TOKEN"
      dataset: minimal

actions:
- deploy:
    to: fvp
    images:
      bl1:
        url: {{ BL1_ARTIFACT }}
      cs1000:
        url: {{ FIRMWARE_ARTIFACT }}
      extsys:
        url: {{ EXTSYS_ARTIFACT }}
      mmc0:
        url: {{ IMAGE_ARTIFACT }}
        compression: gz

- boot:
    method: fvp
    docker:
      name: "{{ CI_REGISTRY_IMAGE }}/cs1k-fvp-test-image:{{ DOCKER_IMAGE_TAG }}"
      container_name: cs1kfvp
    image: /opt/models/Linux64_GCC-9.3/FVP_Corstone-1000
    version_string: 'Fast Models [^\\n]+'
    timeout:
      minutes: 20
    console_string: 'host_terminal_0: Listening for serial connection on port (?P<PORT>\d+)'
    feedbacks:
      - '(?P<NAME>host_terminal_1): Listening for serial connection on port (?P<PORT>\d+)'
      - '(?P<NAME>secenc_terminal): Listening for serial connection on port (?P<PORT>\d+)'
      - '(?P<NAME>extsys_terminal): Listening for serial connection on port (?P<PORT>\d+)'
    arguments:
      - "-C se.trustedBootROMloader.fname={BL1}"
      - "-C board.msd_mmc.p_mmc_file={MMC0}"
      - "-C extsys_harness0.extsys_flashloader.fname={EXTSYS}"
      - "-C extsys0.extsys_terminal.start_telnet=1"
      - "-C host.host_terminal_0.start_telnet=1"
      - "-C host.host_terminal_1.start_telnet=1"
      - "-C se.secenc_terminal.start_telnet=1"
      - "--data board.flash0={CS1000}@0x68000000"
    auto_login:
      login_prompt: 'corstone1000-fvp login:.*'
      username: cassini
      login_commands:
        - cassini123
        - cassini123
        - sudo su -
        - eth0=$(ip -o link show | grep "link/ether" | head -n 1 | awk '-F:' '{print $2}')
        - wait-online.sh $eth0
    prompts:
      - 'New password: '
      - 'Re-enter new password: '
      - '@corstone1000-fvp:.+\$ '
      - '@corstone1000-fvp:.+# '
    transfer_overlay:
      download_command: wget -S
      unpack_command: tar -C / -xzf

# CORSTONE-FVP
- test:
    timeout:
      minutes: 10
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Greengrass-Sanity-Test
            description: 'Greengrass-Sanity-Test'
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - export GG_HOME={{ GG_HOME }}
              - export IOT_KEY_NAME=rsa-signed-key-{{ MACHINE }}-{{ CI_JOB_ID }}
              - sudo mkdir /tmp/idt
              - sudo chown -R cassini:cassini /tmp/idt
              - sudo parsec-tool create-rsa-key -s --key-name $IOT_KEY_NAME
              - sudo parsec-tool create-csr --key-name $IOT_KEY_NAME --cn $IOT_KEY_NAME >$GG_HOME/$IOT_KEY_NAME.csr
              - sudo chmod 755 $GG_HOME
              - sudo chown -R cassini:cassini $GG_HOME
        from: inline
        name: Greengrass-Sanity-Test
        path: inline/Greengrass-Sanity-Test.yaml

# Tester - Provision Device Under Test
- test:
    docker:
      image: {{ IDT_GREENGRASS_IMAGE }}
      network_from: cs1kfvp
    timeout:
      minutes: 15
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Greengrass-Provision-DUT
            description: "Greengrass Provision DUT"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - aws configure set aws_access_key_id {{ AWS_ACCESS_KEY_ID }}
              - aws configure set aws_secret_access_key {{ AWS_SECRET_ACCESS_KEY }}
              - aws configure set region {{ AWS_DEFAULT_REGION }}
              - export IOT_THING_NAME=Device-Cassini-Greengrass-Thing-{{ MACHINE }}-{{ CI_JOB_ID }}
              - export THING_IP="127.0.0.1"
              - export TARGET_PORT="2222"
              - export IOT_KEY_NAME=rsa-signed-key-{{ MACHINE }}-{{ CI_JOB_ID }}
              - export IOT_TE_ROLE_ALIAS={{ IOT_TE_ROLE_ALIAS }}
              - export IOT_TE_ROLE_POLICY_ALIAS={{ IOT_TE_ROLE_POLICY_ALIAS }}
              - export IOT_THING_POLICY={{ IOT_THING_POLICY }}
              - export IOT_THING_GROUP={{ IOT_THING_GROUP }}
              - mkdir -p ${GG_HOME}
              - scp -P $TARGET_PORT -o "StrictHostKeyChecking no" cassini@$THING_IP:$GG_HOME/$IOT_KEY_NAME.csr $GG_HOME/
              - /tester/scripts/iot_device_provision.sh
              - rm $GG_HOME/$IOT_KEY_NAME.csr
              - scp -P $TARGET_PORT -o "StrictHostKeyChecking no" $GG_HOME/* cassini@$THING_IP:$GG_HOME/
        from: inline
        name: Greengrass-Provision-DUT
        path: inline/Greengrass-Provision-DUT.yaml

# CORSTONE-FVP - Start Greengrass with generated parameters
- test:
    timeout:
      minutes: 30
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Greengrass-Setup-DUT
            description: 'Greengrass Setup DUT'
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - export IOT_THING_NAME=Device-Cassini-Greengrass-Thing-{{ MACHINE }}-{{ CI_JOB_ID }}
              - export IOT_THING_GROUP={{ IOT_THING_GROUP }}
              - export AWS_DEFAULT_REGION={{ AWS_DEFAULT_REGION }}
              - export GG_HOME={{ GG_HOME }}
              - sudo systemctl stop greengrass
              - rm -rf ${GG_HOME}/logs/*
              - |
              - sudo -E java -Droot="${GG_HOME}" -Dlog.store=FILE -jar "${GG_HOME}/alts/init/distro/lib/Greengrass.jar"
                             --init-config "${GG_HOME}/generated_config.yml"
                             --trusted-plugin "${GG_HOME}/aws.greengrass.crypto.ParsecProvider.jar"
                             --aws-region "${AWS_DEFAULT_REGION}"
                             --thing-name "${IOT_THING_NAME}"
                             --thing-group-name "${IOT_THING_GROUP}"
                             --component-default-user ggc_user:ggc_group
                             --setup-system-service true
                             --start true
                             --provision false
              - |
                until
                  systemctl is-active --quiet greengrass
                do
                  sleep 15
                done
        from: inline
        name: Greengrass-Setup-DUT
        path: inline/Greengrass-Setup-DUT.yaml

# Tester - Run IoT device tester
- test:
    docker:
      image: {{ IDT_GREENGRASS_IMAGE }}
      network_from: cs1kfvp
    timeout:
      minutes: 480
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Greengrass-Run-IDT
            description: "Greengrass Run IDT"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - aws configure set aws_access_key_id {{ AWS_ACCESS_KEY_ID }}
              - aws configure set aws_secret_access_key {{ AWS_SECRET_ACCESS_KEY }}
              - aws configure set region {{ AWS_DEFAULT_REGION }}
              - export THING_IP="127.0.0.1"
              - export TARGET_PORT="2222"
              - export TARGET_MACHINE={{ MACHINE }}
              - export IDT_ROLE={{ IDT_ROLE }}
              - export TEST_TIMEOUT_MULTIPLIER=4
              - export TEST_SESSION_NAME=IDT-Session-{{ CI_JOB_ID }}
              - export IDT_ROLE_SESSION_DURATION={{ IDT_ROLE_SESSION_DURATION }}
              - /tester/scripts/generate_device_config.sh
              - lava-test-case cassini-greengrass-tests --shell "timeout --foreground 470m /tester/scripts/run_tests.sh"
              - export gg_report_path=$(find /tester/devicetester_greengrass_v2_linux/results/ -xdev -name GGV2Q_Report.xml)
              - jfrog config add --insecure-tls=true artifactory-aws --interactive=false --artifactory-url={{ ARTIFACTORY_AWS_URL }} --user={{ ARTIFACTORY_USER }} --password={{ ARTIFACTORY_PASS }};
              - |
                cat << EOF > ./upload_spec.json
                {
                  "files": [
                    {
                      "pattern": "${gg_report_path}",
                      "target": "{{ ARTIFACTORY_NAMESPACE }}.{{ ARTIFACTORY_TMP_REPO }}/{{ CI_PROJECT_NAME }}/{{ CI_JOB_ID }}/greengrass-results/TEST-Greengrass-test-report.xml",
                      "flat": "true",
                      "recursive": "true"
                    }
                  ]
                }
                EOF
              - build_name="{{ ARTIFACTORY_NAMESPACE }}/{{ CI_PROJECT_PATH }}/{{ CI_JOB_NAME }}"
              - jfrog rt upload --insecure-tls=true --spec=upload_spec.json --build-name="${build_name}" --build-number="{{ CI_JOB_ID }}"
              # Collect environment variables and attach them to a build.
              - jfrog rt build-collect-env "${build_name}" "{{ CI_JOB_ID }}"
              # Publish build info to Artifactory and discard old builds
              - |
                jfrog rt build-publish --insecure-tls=true "${build_name}" "{{ CI_JOB_ID }}" --build-url="{{ CI_PROJECT_URL }}" &&
                jfrog rt build-discard --insecure-tls=true "${build_name}" --max-builds=10 --delete-artifacts --async ||
                echo "Info: build info not supported by Artifactory"
        from: inline
        name: Greengrass-Run-IDT
        path: inline/Greengrass-Run-IDT.yaml

# Tester - Cleanup
- test:
    docker:
      image: {{ IDT_GREENGRASS_IMAGE }}
      network_from: cs1kfvp
    timeout:
      minutes: 10
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Greengrass-Cleanup-Tests
            description: "Greengrass Cleanup Tests"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - aws configure set aws_access_key_id {{ AWS_ACCESS_KEY_ID }}
              - aws configure set aws_secret_access_key {{ AWS_SECRET_ACCESS_KEY }}
              - aws configure set region {{ AWS_DEFAULT_REGION }}
              - export IOT_THING_NAME=Device-Cassini-Greengrass-Thing-{{ MACHINE }}-{{ CI_JOB_ID }}
              - /tester/scripts/aws_cleanup.sh
        from: inline
        name: Greengrass-Cleanup-Tests
        path: inline/Greengrass-Cleanup-Tests.yaml
